package org.bwapi.unit;

import org.bwapi.proxy.ProxyBotFactory;
import org.bwapi.unit.model.BroodwarGameType;
import org.bwapi.unit.model.BroodwarMap;
import org.bwapi.unit.model.BroodwarPlayer;

/**
 * Simple POJO representing test information for
 * a bot execution
 * 
 * @author Chad Retz, dlwh
 */
public class BwapiTestInformation {

    private String starcraftFolder;
    private String chaosLauncherFolder;
    private BroodwarMap map;
    private BroodwarGameType gameType;
    private BroodwarPlayer[] players;
    private boolean consideredOverWhenUnitsGone = false;
		private ProxyBotFactory factory;

    public BwapiTestInformation() {
    }

    public BwapiTestInformation(String starcraftFolder,
            String chaosLauncherFolder, ProxyBotFactory factory,
            BroodwarMap map, BroodwarGameType gameType, BroodwarPlayer... players) {
        this(starcraftFolder, chaosLauncherFolder, factory, map, gameType, 
                false, players);
    }
    
    public BwapiTestInformation(String starcraftFolder,
            String chaosLauncherFolder, ProxyBotFactory factory, 
            BroodwarMap map, BroodwarGameType gameType, 
            boolean consideredOverWhenUnitsGone, BroodwarPlayer... players) {
        this.starcraftFolder = starcraftFolder;
        this.chaosLauncherFolder = chaosLauncherFolder;
        this.map = map;
        this.gameType = gameType;
        this.consideredOverWhenUnitsGone = consideredOverWhenUnitsGone;
        this.players = players;
        this.setFactory(factory);
    }

    public String getStarcraftFolder() {
        return starcraftFolder;
    }

    public void setStarcraftFolder(String starcraftFolder) {
        this.starcraftFolder = starcraftFolder;
    }

    public String getChaosLauncherFolder() {
        return chaosLauncherFolder;
    }

    public void setChaosLauncherFolder(String chaosLauncherFolder) {
        this.chaosLauncherFolder = chaosLauncherFolder;
    }

    public BroodwarMap getMap() {
        return map;
    }

    public void setMap(BroodwarMap map) {
        this.map = map;
    }
    
    public BroodwarGameType getGameType() {
        return gameType;
    }
    
    public void setGameType(BroodwarGameType gameType) {
        this.gameType = gameType;
    }
    
    public boolean isConsideredOverWhenUnitsGone() {
        return consideredOverWhenUnitsGone;
    }
    
    public void setConsideredOverWhenUnitsGone(
            boolean consideredOverWhenUnitsGone) {
        this.consideredOverWhenUnitsGone = consideredOverWhenUnitsGone;
    }
    
    public BroodwarPlayer[] getPlayers() {
        return players;
    }
    
    public void setPlayers(BroodwarPlayer[] players) {
        this.players = players;
    }

		public void setFactory(ProxyBotFactory factory) {
	    this.factory = factory;
    }

		public ProxyBotFactory getFactory() {
	    return factory;
    }

}
